]> git.ozlabs.org Git - yaboot.git/blob - ybin/ofpath
19e9f565ec97d2607350e51fb030513586b845e8
[yaboot.git] / ybin / ofpath
1 #! /bin/sh
2
3 ###############################################################################
4 ##
5 ## ofpath: determine OpenFirmware path from unix device node
6 ## Copyright (C) 2000, 2001, 2002 Ethan Benson
7 ##
8 ## Portions based on show_of_path.sh:
9 ##
10 ## Copyright (C) 2000 Olaf Hering <olh@suse.de>
11 ## 
12 ## This program is free software; you can redistribute it and/or
13 ## modify it under the terms of the GNU General Public License
14 ## as published by the Free Software Foundation; either version 2
15 ## of the License, or (at your option) any later version.
16 ##
17 ## This program is distributed in the hope that it will be useful,
18 ## but WITHOUT ANY WARRANTY; without even the implied warranty of
19 ## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
20 ## GNU General Public License for more details.
21 ##
22 ## You should have received a copy of the GNU General Public License
23 ## along with this program; if not, write to the Free Software
24 ## Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
25 ##
26 ###############################################################################
27
28 PATH="/sbin:/bin:/usr/sbin:/usr/bin:/usr/local/sbin:/usr/local/bin"
29 PRG="${0##*/}"
30 VERSION=1.0.3-DEVEL_DO_NOT_DISTRIBUTE-patch-37
31 DEBUG=0
32 export LC_COLLATE=C
33
34 ## --version output.
35 version()
36 {
37 echo \
38 "$PRG $VERSION
39 Written by Ethan Benson
40 Portions based on show_of_path.sh written by Olaf Hering
41
42 Copyright (C) 2000, 2001, 2002 Ethan Benson
43 Portions Copyright (C) 2000 Olaf Hering
44 This is free software; see the source for copying conditions.  There is NO
45 warranty; not even for MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE."
46 }
47
48 ## --help output.
49 usage()
50 {
51 echo \
52 "Usage: $PRG [OPTION]... FILE
53 Find OpenFirmware device path from unix device node.
54
55       --debug                print boring junk only useful for debugging
56   -h, --help                 display this help and exit
57   -V, --version              output version information and exit"
58 }
59
60 ## a small seq replacement, seq is not present on boot/rescue floppies.
61 smallseq()
62 {
63     local v="$1"
64     local n=1
65     echo 1
66     while [ "$v" -gt 1 ] ; do
67         echo "$(($n + 1))"
68         local n="$(($n + 1))"
69         local v="$(($v - 1))"
70     done
71     return 0
72 }
73
74 ## a kludge to replace wc -l, wc is not present on boot/rescue
75 ## floppies. max file is 145 lines, 3 hosts * 16 devs each * 3 lines
76 ## per device, + 1 "Attached Devices:" line.
77 linecount()
78 {
79     if [ $# = 0 ] ; then
80         local file="$(cat)"
81         local v="$file"
82     else
83         local file="$(cat $1)"
84         local v="$file"
85     fi
86
87     if [ -z "$file" ] ; then
88         echo 0
89         return 0
90     fi
91
92     ## use real wc if available
93     if (command -v wc > /dev/null 2>&1) ; then
94         if [ -x `command -v wc` ] ; then
95             lines="$(echo "$file" | wc -l)"
96             if [ $? = 0 ] ; then
97                 echo $lines
98                 unset lines
99                 return 0
100             fi
101         fi
102     fi
103
104     while true ; do
105         for i in `smallseq 145` ; do
106             local b="$(echo "$file" | tail -n $i)"
107             if [ "$v" = "$b" ] ; then
108                 echo "$i"
109                 break 2
110             fi
111         done
112     done
113     return 0
114 }
115
116 ## small tr replacment which handles a specific need of this script.
117 smalltr()
118 {
119     case "$1" in 
120         a) echo 1 ;; b) echo 2 ;; c) echo 3 ;; d) echo 4 ;; e) echo 5 ;; f) echo 6 ;;
121         g) echo 7 ;; h) echo 8 ;; i) echo 9 ;; j) echo 10 ;; k) echo 11 ;; l) echo 12 ;;
122         m) echo 13 ;; n) echo 14 ;; o) echo 15 ;; p) echo 16 ;;
123         1) echo a ;; 2) echo b ;; 3) echo c ;; 4) echo d ;; 5) echo e ;; 
124         6) echo f ;; 7) echo g ;; 8) echo h ;; 9) echo i ;; 10) echo j ;;
125         11) echo k ;; 12) echo l ;; 13) echo m ;; 14) echo n ;; 15) echo o ;;
126         16) echo p ;;
127     esac
128     return 0
129 }
130
131 ## replacment for grep -l which is not supported by busybox grep.
132 ## echo $(cat..) hack needed because busybox grep barfs with `line too
133 ## long' when fed /proc files.  the for loop is needed since busybox
134 ## grep seems to have somewhat broken regexp support.
135 ## usage: lgrep filename regexp regexp ...
136 lgrep()
137 {
138     local f="$1"
139     shift
140     for i in "$@" ; do
141         echo "$(cat "$f")" | grep -q "$i" && echo "$f" && break
142     done
143     return 0
144 }
145
146 ## if readlink is missing use a kludge
147 if (command -v readlink > /dev/null 2>&1) ; then
148     true
149 else
150     readlink()
151     {
152         local SYMTARGET="$(v=`ls -l "$2" 2>/dev/null` ; echo ${v##*> })"
153         if [ -n "$SYMTARGET" ] ; then
154             echo "$SYMTARGET"
155             return 0
156         else
157             return 1
158         fi
159     }
160 fi
161
162 ## a function to print relevant scsi host path when there is more then
163 ## one.  this function also takes care of stripping off the trailing
164 ## /compatible.
165 printhost()
166 {
167     case "$1" in
168         1)
169         echo "${2%/*}"
170         ;;
171         2)
172         echo "${3%/*}"
173         ;;
174         3)
175         echo "${4%/*}"
176         ;;
177         4)
178         echo "${5%/*}"
179         ;;
180     esac
181     return 0
182 }
183
184 ## this finds information we need on both newworld and oldworld macs.
185 ## mainly what scsi host a disk is attached to.
186 scsiinfo()
187 {
188     ## see if system has scsi at all
189     if [ ! -f /proc/scsi/scsi ] ; then
190         echo 1>&2 "$PRG: /dev/$DEVNODE: Device not configured"
191         return 1
192     fi
193
194     ## first we have to figure out the SCSI ID, have to do that
195     ## anyway [to] find the attached scsi disks = "Direct-Access" and
196     ## stop at sda=1 sdb=2 or whatever count in 3 lines steps
197
198     ## get last letter of device node, ie sda -> a
199     SUBNODE=${DEVNODE##*sd}
200
201     ## turn SUBNODE above into a number starting at 1, ie a -> 1
202     SUBDEV="$(smalltr $SUBNODE)"
203     [ "$DEBUG" = 1 ] && echo 1>&2 "$PRG: DEBUG: SUBNODE=$SUBNODE SUBDEV=$SUBDEV"
204
205     DEVCOUNT=0
206
207     ## copy scsi file into a variable removing "Attached Devices"
208     ## which is the first line. this avoids a lot of
209     ## [incmopatible] crap later, and improves readability.
210
211     ## find number of lines once and recycle that number, to save
212     ## some time (linecount is a bit slow). subtract one line
213     ## to scrap Attached Devices:
214
215     SCSILINES="$(($(linecount /proc/scsi/scsi) - 1))"
216
217     if [ "$SUBDEV" -gt "$(cat /proc/scsi/scsi | grep Direct-Access | linecount)" ] ; then
218         echo 1>&2 "$PRG: /dev/$DEVNODE: Device not configured"
219         return 1
220     fi
221
222     PROCSCSI="$(cat /proc/scsi/scsi | tail -n $SCSILINES)"
223
224     for i in $(smallseq $(($SCSILINES / 3))) ; do
225
226         ## put every scsi device into one single line
227         DEVINFO="$(echo "$PROCSCSI" | head -n $(($i * 3)) | tail -n 3)"
228         [ "$DEBUG" = 1 ] && echo 1>&2 "$PRG: DEBUG: DEVINFO=$DEVINFO"
229
230         ## cut the type field, expect "Direct-Access" later.
231         DEVTYPE="$(v=$(echo ${DEVINFO##*Type: }) ; echo ${v%% *})"
232         [ "$DEBUG" = 1 ] && echo 1>&2 "$PRG: DEBUG: DEVTYPE=$DEVTYPE"
233
234         ## get the device id.
235         DEVID="$(v=$(echo ${DEVINFO##*Id: }) ; n=$(echo ${v%% *}) ; echo ${n#*0})"
236         [ "$DEBUG" = 1 ] && echo 1>&2 "$PRG: DEBUG: DEVID=$DEVID"
237
238         ## get the scsi host id.
239         DEVHOST="$(v=$(echo ${DEVINFO##*Host: scsi}) ; echo ${v%% *})"
240         [ "$DEBUG" = 1 ] && echo 1>&2 "$PRG: DEBUG: DEVHOST=$DEVHOST"
241
242         if [ "$DEVTYPE" = "Direct-Access" ] ; then
243             DEVCOUNT="$(($DEVCOUNT + 1))"
244             [ "$DEBUG" = 1 ] && echo 1>&2 "$PRG: DEBUG: DEVCOUNT=$DEVCOUNT"
245             if [ "$SUBDEV" = "$DEVCOUNT" ] ; then
246                 DEVICE_HOST=$DEVHOST
247                 DEVICE_ID=$DEVID
248                 [ "$DEBUG" = 1 ] && echo 1>&2 "$PRG: DEBUG: DEVICE_HOST=$DEVICE_HOST"
249                 break
250             fi
251         fi
252     done
253
254     ## figure out what the scsi driver is, it is /proc/scsi/dirname.
255     [ "$DEBUG" = 1 ] && echo 1>&2 "$PRG: DEBUG: DEVICE_HOST=$DEVICE_HOST"
256     SCSI_DRIVER="$(x=`ls /proc/scsi/*/$DEVICE_HOST 2>/dev/null | cat` ; y=`echo ${x##*proc/scsi/}` ; echo ${y%%/*})"
257     [ "$DEBUG" = 1 ] && echo 1>&2 "$PRG: DEBUG: SCSI_DRIVER=$SCSI_DRIVER"
258
259     ## figure out which host we found.
260     SCSI_HOSTNUMBER="$(v=`ls /proc/scsi/$SCSI_DRIVER/* 2>/dev/null | cat | grep -n "$DEVICE_HOST\>"` ; echo ${v%%:*})"
261     [ "$DEBUG" = 1 ] && echo 1>&2 "$PRG: DEBUG: SCSI_HOSTNUMBER=$SCSI_HOSTNUMBER"
262
263     return 0
264 }
265
266 ## generic function that can find OF device paths for scsi devices,
267 ## must be run after scsiinfo().
268 scsi_ofpath()
269 {
270     case "$SCSI_DRIVER" in
271         aic7xxx)
272             HOST_LIST="$(for i in `find /proc/device-tree -name compatible` ; do
273                         lgrep "$i" "^ADPT" "^pci900[45]" "^pciclass,01000" ; done)"
274             DEVICE_PATH="$(printhost $SCSI_HOSTNUMBER $HOST_LIST)"
275             echo "${DEVICE_PATH##*device-tree}/@$DEVICE_ID:$PARTITION"
276             ;;
277         sym53c8xx)
278             HOST_LIST="$(for i in `find /proc/device-tree -name compatible` ; do
279                         lgrep "$i" "^Symbios" "^pci1000" "^pciclass,01000" ; done)"
280             DEVICE_PATH="$(printhost $SCSI_HOSTNUMBER $HOST_LIST)"
281             echo "${DEVICE_PATH##*device-tree}/@$DEVICE_ID:$PARTITION"
282             ;;
283         mesh)
284             HOST_LIST="$(for i in `find /proc/device-tree -name compatible` ; do
285                         lgrep "$i" "mesh" ; done)"
286             DEVICE_PATH="$(printhost $SCSI_HOSTNUMBER $HOST_LIST)"
287             echo "${DEVICE_PATH##*device-tree}/@$DEVICE_ID:$PARTITION"
288             ;;
289         *)
290             echo 1>&2 "$PRG: Driver: $SCSI_DRIVER is not supported"
291             return 1
292             ;;
293     esac
294     return 0
295 }
296
297 ide_ofpath()
298 {
299     if [ ! -L "/proc/ide/$DEVNODE" ] ; then
300         echo 2>&1 "$PRG: /dev/$DEVNODE: Device not configured"
301         return 1
302     fi
303
304     local IDEBUS="$(v=`readlink /proc/ide/$DEVNODE` ; echo ${v%%/*} )"
305     if [ -z "$IDEBUS" ] ; then
306         echo 1>&2 "$PRG: BUG: IDEBUS == NULL"
307         return 1
308     fi
309     local OF1275IDE="/proc/ide/$IDEBUS/devspec"
310
311     if [ ! -f "$OF1275IDE" ] ; then
312         case "$(cat /proc/device-tree/model)" in
313             "PowerMac3,6")
314                 local CDROM="$(grep "^drive name:" /proc/sys/dev/cdrom/info 2> /dev/null | grep $DEVNODE)"
315                 if [ -z "$CDROM" ] ; then
316                     echo "ultra2:$PARTITION"
317                 else
318                     echo "cd:$PARTITION"
319                 fi
320                 ;;
321             *)
322                 local CDROM="$(grep "^drive name:" /proc/sys/dev/cdrom/info 2> /dev/null | grep $DEVNODE)"
323                 if [ -z "$CDROM" ] ; then
324                     if [ "$DEVNODE" = hda ] ; then
325                         echo "hd:$PARTITION"
326                     else
327                         echo "ultra1:$PARTITION"
328                     fi
329                 else
330                     echo "cd:$PARTITION"
331                 fi
332                 ;;
333         esac
334     else
335         local DEVSPEC="$OF1275IDE"
336         [ "$DEBUG" = 1 ] && echo 1>&2 "$PRG: DEBUG: DEVSPEC=$DEVSPEC"
337         if [ -z "$DEVSPEC" ] ; then
338             echo 1>&2 "$PRG: KERNEL BUG: $OF1275IDE exists, but is empty"
339             return 1
340         fi
341         case "$DEVNODE" in
342             hda|hdc|hde|hdg|hdi)
343                 echo "${DEVSPEC}/disk@0:$PARTITION"
344                 return 0
345                 ;;
346             hdb|hdd|hdf|hdh|hdj)
347                 echo "${DEVSPEC}/disk@1:$PARTITION"
348                 return 0
349                 ;;
350             *)
351                 echo 1>&2 "$PRG: /dev/$DEVNODE is not supported"
352                 return 1
353                 ;;
354         esac
355     fi
356 }
357
358 ## figure out the OpenFirmware device path for newworld macs.
359 ## sd* scsi disks , hd* ide disks.
360 newworld()
361 {
362     case "$DEVNODE" in
363         sd*)
364             if ls -l /proc/device-tree | grep -q ^lr ; then
365                 true
366             else
367                 echo 1>&2 "$PRG: /proc/device-tree is broken.  Do not use BootX to boot, use yaboot."
368                 echo 1>&2 "$PRG: The yaboot HOWTO can be found here: http://www.alaska.net/~erbenson/doc"
369                 return 1
370             fi
371
372             ## use common scsiinfo function to get info we need.
373             scsiinfo || return 1
374
375             ## now we have the data for /@$DEVID:$PARTITION
376             ## find the actual OF path. 
377             scsi_ofpath || return 1
378             ;;
379         hd*)
380             ide_ofpath || return 1
381             ;;
382         *)
383             echo 1>&2 "$PRG: Device: /dev/$DEVNODE is not supported"
384             return 1
385             ;;
386     esac
387     return 0
388 }
389
390 oldworld()
391 {
392     ## for some reason 2.4 kernels put OF aliases in aliases@0/ instead of plain aliases/
393     if [ -d "/proc/device-tree/aliases" ] ; then
394         local ALIASES="aliases"
395     elif [ -d "/proc/device-tree/aliases@0" ] ; then
396         local ALIASES="aliases@0"
397     else
398         echo 1>&2 "$PRG: Cannot find OpenFirmware aliases directory in /proc/device-tree/"
399         return 1
400     fi
401
402     local MODEL="$(cat /proc/device-tree/compatible)"
403     [ "$DEBUG" = 1 ] && echo 1>&2 "$PRG: DEBUG: Oldworld subarch: $MODEL"
404
405     case "$MODEL" in
406         AAPL,7300*|AAPL,7500*|AAPL,8500*|AAPL,9500*|AAPL,\?\?\?\?*)
407             case "$DEVNODE" in
408                 sd*)
409                 scsiinfo || return 1
410                 case "$SCSI_DRIVER" in
411                     mesh)
412                     echo $(cat /proc/device-tree/$ALIASES/scsi-int)/sd\@$DEVICE_ID:$PARTITION
413                     ;;
414                     53c94)
415                     echo $(cat /proc/device-tree/$ALIASES/scsi)/sd\@$DEVICE_ID:$PARTITION
416                     ;;
417                     *)
418                     echo 1>&2 "$PRG: Driver $SCSI_DRIVER is not supported"
419                     return 1
420                     ;;
421                 esac
422                 ;;
423                 *)
424                 echo 1>&2 "$PRG: Unsupported device: /dev/$DEVNODE"
425                 return 1
426                 ;;
427             esac
428             ;;
429         AAPL,e407*)
430             case "$DEVNODE" in
431                 sd*)
432                 scsiinfo || return 1
433                 case "$SCSI_DRIVER" in
434                     mesh)
435                     echo $(cat /proc/device-tree/$ALIASES/scsi)/sd\@$DEVICE_ID:$PARTITION
436                     ;;
437                     *)
438                     echo 1>&2 "$PRG: Driver $SCSI_DRIVER is not supported"
439                     return 1
440                     ;;
441                 esac
442                 ;;
443                 hda*)
444                 echo $(cat /proc/device-tree/$ALIASES/ata)/ATA-Disk\@0:$PARTITION
445                 ;;
446                 hdb*)
447                 echo $(cat /proc/device-tree/$ALIASES/ata)/ATA-Disk\@1:$PARTITION
448                 ;;
449                 hd*)
450                 echo 1>&2 "$PRG: Device: /dev/$DEVNODE is not supported"
451                 ;;
452             esac
453             ;;
454         AAPL,e826*)
455             case "$DEVNODE" in
456                 sd*)
457                 scsiinfo || return 1
458                 case "$SCSI_DRIVER" in
459                     mesh)
460                     echo $(cat /proc/device-tree/$ALIASES/scsi)/sd\@$DEVICE_ID:$PARTITION
461                     ;;
462                     *)
463                     echo 1>&2 "$PRG: Driver $SCSI_DRIVER is not supported"
464                     return 1
465                     ;;
466                 esac
467                 ;;
468                 hda*)
469                 echo $(cat /proc/device-tree/$ALIASES/ata)/ata-disk\@0:$PARTITION
470                 ;;
471                 hdb*)
472                 echo $(cat /proc/device-tree/$ALIASES/ata)/ata-disk\@1:$PARTITION
473                 ;;
474                 hd*)
475                 echo 1>&2 "$PRG: Device: /dev/$DEVNODE is not supported"
476                 ;;
477             esac
478             ;;
479         AAPL,Gossamer*|AAPL,PowerMac\ G3*)
480             case "$DEVNODE" in
481                 sd*)
482                 scsiinfo || return 1
483                 case "$SCSI_DRIVER" in
484                     mesh)
485                     echo $(cat /proc/device-tree/$ALIASES/scsi)/sd\@$DEVICE_ID:$PARTITION
486                     ;;
487                     *)
488                     echo 1>&2 "$PRG: Driver $SCSI_DRIVER is not supported"
489                     return 1
490                     ;;
491                 esac
492                 ;;
493                 hda*)
494                 echo $(cat /proc/device-tree/$ALIASES/ide0)/ata-disk\@0:$PARTITION
495                 ;;
496                 hdb*)
497                 echo $(cat /proc/device-tree/$ALIASES/ide0)/ata-disk\@1:$PARTITION
498                 ;;
499                 hdc*)
500                 echo $(cat /proc/device-tree/$ALIASES/ide1)/ata-disk\@0:$PARTITION
501                 ;;
502                 hdd*)
503                 echo $(cat /proc/device-tree/$ALIASES/ide1)/ata-disk\@1:$PARTITION
504                 ;;
505                 hd*)
506                 echo 1>&2 "$PRG: Device: /dev/$DEVNODE is not supported"
507                 ;;
508             esac
509             ;;
510         AAPL,PowerBook1998*)
511             if [ -f  /proc/device-tree/$ALIASES/ata0 ] ; then
512                 local ATA0=ata0
513             else
514                 local ATA0=ide0
515             fi
516             if [ -f  /proc/device-tree/$ALIASES/ata1 ] ; then
517                 local ATA1=ata1
518             else
519                 local ATA1=bay-ata1
520             fi
521             case "$DEVNODE" in
522                 sd*)
523                 scsiinfo || return 1
524                 case "$SCSI_DRIVER" in
525                     mesh)
526                     echo $(cat /proc/device-tree/$ALIASES/scsi)/sd\@$DEVICE_ID:$PARTITON
527                     ;;
528                     *)
529                     echo 1>&2 "$PRG: Driver $SCSI_DRIVER is not supported"
530                     return 1
531                     ;;
532                 esac
533                 ;;
534                 hda*)
535                 echo $(cat /proc/device-tree/$ALIASES/$ATA0)/ata-disk\@0:$PARTITION
536                 ;;
537                 hdb*)
538                 echo $(cat /proc/device-tree/$ALIASES/$ATA0)/ata-disk\@1:$PARTITION
539                 ;;
540                 hdc*)
541                 echo $(cat /proc/device-tree/$ALIASES/$ATA1)/atapi-disk\@0:$PARTITION
542                 ;;
543                 hdd*)
544                 echo $(cat /proc/device-tree/$ALIASES/$ATA1)/atapi-disk\@1:$PARTITION
545                 ;;
546                 *)
547                 echo 1>&2 "$PRG: Unsupported device: /dev/$DEVNODE"
548                 return 1
549                 ;;
550             esac
551             ;;
552         AAPL,3400/2400*)
553             case "$DEVNODE" in
554                 sd*)
555                 scsiinfo || return 1
556                 case "$SCSI_DRIVER" in
557                     mesh)
558                     echo $(cat /proc/device-tree/$ALIASES/scsi-int)/sd\@$DEVICE_ID:$PARTITON
559                     ;;
560                     53c94)
561                     echo $(cat /proc/device-tree/$ALIASES/scsi)/sd\@$DEVICE_ID:$PARTITON
562                     ;;
563                     *)
564                     echo 1>&2 "$PRG: Driver $SCSI_DRIVER is not supported"
565                     return 1
566                     ;;
567                 esac
568                 ;;
569                 hda*)
570                 echo $(cat /proc/device-tree/$ALIASES/ata0)/ata-disk\@0:$PARTITION
571                 ;;
572                 hdb*)
573                 echo $(cat /proc/device-tree/$ALIASES/ata0)/ata-disk\@1:$PARTITION
574                 ;;
575                 hdc*)
576                 echo $(cat /proc/device-tree/$ALIASES/ata1)/atapi-disk\@0:$PARTITION
577                 ;;
578                 hdd*)
579                 echo $(cat /proc/device-tree/$ALIASES/ata1)/atapi-disk\@1:$PARTITION
580                 ;;
581                 hde*)
582                 echo $(cat /proc/device-tree/$ALIASES/ata2):$PARTITION
583                 ;;
584                 hdf*)
585                 echo $(cat /proc/device-tree/$ALIASES/ata3):$PARTITION
586                 ;;
587                 *)
588                 echo 1>&2 "$PRG: Unsupported device: /dev/$DEVNODE"
589                 return 1
590                 ;;
591             esac
592             ;;
593         *)
594             echo 1>&2 "$PRG: This machine is not supported: $MODEL"
595             return 1
596             ;;
597     esac
598     return 0
599 }
600
601 ## find OpenFirmware device path for IBM CHRP hardware (scsi only)
602 chrp()
603 {
604     case "$DEVNODE" in
605         sd*)
606             if ls -l /proc/device-tree | grep -q ^lr ; then
607                 true
608             else
609                 echo 1>&2 "$PRG: /proc/device-tree is broken."
610                 return 1
611             fi
612
613             ## use common scsiinfo function to get info we need.
614             scsiinfo || return 1
615
616             ## now we have the data for /@$DEVID:$PARTITION
617             ## find the actual OF path. 
618             scsi_ofpath || return 1
619             ;;
620         *)
621             echo 1>&2 "$PRG: Device: /dev/$DEVNODE is not supported"
622             return 1
623             ;;
624     esac
625     return 0
626 }
627
628 ## If we get lame devfs name, we need to make it foad
629 ckdevfs()
630 {
631     case "$1" in
632         /dev/ide/*|/dev/scsi/*|/dev/discs/*)
633         return 0
634         ;;
635         *)
636         return 1
637         ;;
638     esac
639 }
640
641 ## convert devfs names into normal short ones, written by Tom Rini.
642 fixdevfs()
643 {
644     ## get partition number, if any
645     local PARTNUM="${1##*[a-z]}"
646     ## Find the bus type.
647     local TYPE="$(v=${1#/dev/} ; echo ${v%/host*})"
648     ## Find the host number.
649     local HOST="$(v=${1#/dev/*/host} ; echo ${v%/bus*})"
650     ## Find the bus number.
651     local BUS="$(v=${1#/dev/*/bus} ; echo ${v%/tar*})"
652     ## Find the target.
653     local TARGET="$(v=${1#/dev/*/target} ; echo ${v%/lun*})"
654
655     case "$TYPE" in
656         ide)
657         case "$HOST" in
658             0)
659             case "$TARGET" in
660                 0)
661                 local DEV=hda
662                 ;;
663                 1)
664                 local DEV=hdb
665                 ;;
666             esac
667             ;;
668             1)
669             case "$TARGET" in
670                 0)
671                 local DEV=hdc
672                 ;;
673                 1)
674                 local DEV=hdd
675                 ;;
676             esac
677             ;;
678             *)
679                 echo 1>&2 "$PRG: $1: Unable to translate this device, try again without devfs."
680                 return 1
681         esac
682         local DEV="${DEV}${PARTNUM}"
683         echo "/dev/$DEV"
684         return 0
685         ;;
686         scsi)
687         local LUN="$(v=${1#/dev/*/lun} ; echo ${v%/*})"
688
689         ## In this case, we need to figure out what number our device is
690         local DEVCOUNT=0
691
692         ## copy scsi file into a variable removing "Attached Devices"
693         ## which is the first line. this avoids a lot of
694         ## [incmopatible] crap later, and improves readability.
695
696         ## find number of lines once and recycle that number, to save
697         ## some time (linecount is a bit slow). subtract one line
698         ## to scrap Attached Devices:
699
700         local SCSILINES="$(($(linecount /proc/scsi/scsi) - 1))"
701         local PROCSCSI="$(cat /proc/scsi/scsi | tail -n $SCSILINES)"
702
703         for i in $(smallseq $(($SCSILINES / 3))) ; do
704
705             ## put every scsi device into one single line
706             local DEVINFO="$(echo "$PROCSCSI" | head -n $(($i * 3)) | tail -n 3)"
707             [ "$DEBUG" = 1 ] && echo 1>&2 "$PRG: DEBUG: fixdevfs: DEVINFO=$DEVINFO"
708
709             ## cut the type field, expect "Direct-Access" later.
710             local DEVTYPE="$(v=$(echo ${DEVINFO##*Type: }) ; echo ${v%% *})"
711             [ "$DEBUG" = 1 ] && echo 1>&2 "$PRG: DEBUG: fixdevfs: DEVTYPE=$DEVTYPE"
712
713             if [ "$DEVTYPE" = "Direct-Access" ] ; then
714                 ## Lets find out some more information
715                 ## get the device id.
716                 local DEVID="$(v=$(echo ${DEVINFO##*Id: }) ; n=$(echo ${v%% *}) ; echo ${n#*0})"
717                 [ "$DEBUG" = 1 ] && echo 1>&2 "$PRG: DEBUG: fixdevfs: DEVID=$DEVID"
718
719                 ## get the device lun.
720                 local DEVLUN="$(v=$(echo ${DEVINFO##*Lun: }) ; n=$(echo ${v%% *}) ; echo ${n#*0})"
721                 [ "$DEBUG" = 1 ] && echo 1>&2 "$PRG: DEBUG: fixdevfs: DEVLUN=$DEVLUN"
722
723                 ## get the device channel.
724                 local DEVCHAN="$(v=$(echo ${DEVINFO##*Channel: }) ; n=$(echo ${v%% *}) ; echo ${n#*0})"
725                 [ "$DEBUG" = 1 ] && echo 1>&2 "$PRG: DEBUG: fixdevfs: DEVCHAN=$DEVCHAN"
726
727                 ## get the scsi host id.
728                 local DEVHOST="$(v=$(echo ${DEVINFO##*Host: scsi}) ; echo ${v%% *})"
729                 [ "$DEBUG" = 1 ] && echo 1>&2 "$PRG: DEBUG: fixdevfs: DEVHOST=$DEVHOST"
730
731                 local DEVCOUNT="$(($DEVCOUNT + 1))"
732                 [ "$DEBUG" = 1 ] && echo 1>&2 "$PRG: DEBUG: fixdevfs: DEVCOUNT=$DEVCOUNT"
733                 if [ "$DEVHOST" = "$HOST" -a "$DEVCHAN" = "$BUS" -a \
734                     "$DEVID" = "$TARGET" -a "$DEVLUN" = "$LUN" ] ; then
735                     local DEV="sd$(smalltr $DEVCOUNT)${PARTNUM}"
736                     echo "/dev/$DEV"
737                     return 0
738                 fi
739             fi
740         done
741         echo 1>&2 "$PRG: $1: Unable to translate this device, try again without devfs."
742         return 1
743         ;;
744         *)
745         echo 1>&2 "$PRG: Unknown bus $TYPE"
746         return 1
747         ;;
748     esac
749     ## we should never get here
750     return 1
751 }
752
753 ## make sure that find, head and tail can be found.  otherwise the
754 ## script will silently give bogus paths.  these are the only /usr/*
755 ## utilities this script depends on.
756 checkutils()
757 {
758     if command -v find > /dev/null 2>&1 ; then
759         [ -x `command -v find` ] || FAIL=1 ; else FAIL=1 ; fi
760     if command -v head > /dev/null 2>&1 ; then
761         [ -x `command -v head` ] || FAIL=1 ; else FAIL=1 ; fi
762     if command -v tail > /dev/null 2>&1 ; then
763         [ -x `command -v tail` ] || FAIL=1 ; else FAIL=1 ; fi
764
765     if [ "$FAIL" = 1 ] ; then
766         echo 1>&2 "$PRG: \`find', \`head', or \`tail' could not be found, aborting."
767         return 1
768     else
769         return 0
770     fi
771 }
772
773 ## parse command line switches.
774 if [ $# != 0 ] ; then
775     while true ; do
776         case "$1" in
777             -V|--version)
778                 version
779                 exit 0
780                 ;;
781             -h|--help)
782                 usage
783                 exit 0
784                 ;;
785             --debug)
786                 DEBUG=1
787                 shift
788                 ;;
789             -*)
790                 echo 1>&2 "$PRG: unrecognized option \`$1'"
791                 echo 1>&2 "$PRG: Try \`$PRG --help' for more information."
792                 exit 1
793                 ;;
794             "")
795                 echo 1>&2 "$PRG: You must specify a filename"
796                 echo 1>&2 "Try \`$PRG --help' for more information."
797                 exit 1
798                 ;;
799             *)
800                 device="$1"
801                 break
802                 ;;
803         esac
804     done
805 else
806     echo 1>&2 "$PRG: You must specify a /dev device"
807     echo 1>&2 "Try \`$PRG --help' for more information."
808     exit 1
809 fi
810
811 ## check that FILE is a block device and exists.
812 if [ ! -e "$device" ] ; then
813     echo 1>&2 "$PRG: $device: No such file or directory"
814     exit 1
815 elif [ ! -b "$device" ] ; then
816     echo 1>&2 "$PRG: $device is not a block device"
817     exit 1
818 fi
819
820 ## check that we are running on a GNU/Linux system, OSX/BSD does not
821 ## have the same /proc stuff
822 if [ `uname -s` != Linux ] ; then
823     echo 1>&2 "$PRG: This utility will only work with GNU/Linux"
824     exit 1
825 fi
826
827 ## check for ppc, i think uname -m is safe for this...
828 if [ `uname -m` != ppc ] ; then
829     echo 1>&2 "$PRG: This utility will only work on PowerPC hardware"
830     exit 1
831 fi
832
833 ## ofpath cannot live without procfs
834 if [ ! -f /proc/uptime ] ; then
835     echo 1>&2 "$PRG: This utility requires the /proc filesystem"
836     exit 1
837 fi
838
839 ## check for retarded devfs names and tell them to foad.
840 if ckdevfs "$device" ; then
841     device="$(fixdevfs $device)" || exit 1
842 fi
843
844 ## check for newworld mac. use cat hack due to /proc wierdness.
845 if [ "$(v=`cat /proc/cpuinfo 2>/dev/null | grep pmac-generation` ; echo ${v##*:[ ]})" = NewWorld ] ; then
846     SUBARCH=NewWorld
847 elif [ "$(v=`cat /proc/cpuinfo 2>/dev/null | grep pmac-generation` ; echo ${v##*:[ ]})" = OldWorld ] ; then
848     SUBARCH=OldWorld
849 elif (cat /proc/cpuinfo 2>/dev/null | grep ^motherboard | grep -q AAPL) ; then
850     SUBARCH=OldWorld
851 elif (cat /proc/cpuinfo 2> /dev/null | grep ^machine | grep -q 'CHRP IBM') ; then
852     SUBARCH=CHRP
853 else
854     echo 1>&2 "$PRG: This machine is not yet supported"
855     exit 1
856 fi
857
858 ## make sure /proc/device-tree exists
859 if [ ! -d /proc/device-tree ] ; then
860     echo 1>&2 "$PRG: /proc/device-tree does not exist"
861     echo 1>&2 "$PRG: Make sure you compiled your kernel with CONFIG_PROC_DEVICETREE=y"
862     exit 1
863 fi
864
865 ## make sure we have what we need.
866 checkutils || exit 1
867
868 ## get the base device node and scrap /dev/ ie /dev/hda2 -> hda
869 DEVICE="${device##*/}"
870 DEVNODE="${DEVICE%%[0-9]*}"
871 PARTITION="${DEVICE##*[a-z]}"
872
873 ## use appropriate search for right sub arch.
874 case "$SUBARCH" in
875     NewWorld)
876         newworld || exit 1
877         ;;
878     OldWorld)
879         oldworld || exit 1
880         ;;
881     CHRP)
882         chrp || exit 1
883         ;;
884 esac
885
886 exit 0